CREATE SCHEMA Geometrieschema

-- Historie:
--
-- 29.06.2004 - 1.007 (1.009)
-- Anpassung an ASB-Netzdaten, Stand September 2002
--
-- 03.09.2003 - 1.006 (1.008)
-- Przisierung des Zusammenhangs von Linien
-- Ergnzung von Flchengeometrie fr Erwerbsflche
-- und Nutzungsart_Teilflaeche
-- Anbindung des Schemas kologie
--
-- 31.05.2002 - 1.005 (1.007)
-- Erweiterung Linienelement_3D, Linienelement_Spline
-- gem Dokument N0030
--
-- 24.10.2001 - 1.004 (1.005)
-- Korrekturen in Schlsseltabellen
--
-- 12.09.2001 - 1.003 (1.004)
-- berarbeitung in Folge des nderungsantrags A0006
-- Beziehung zum Schema Unfall ergnzt
--
-- 18.12.2000 - 1.002 (1.002)
-- Korrektur: Ergnzung der Informationen "geschlossen"
-- und "tangentialer Anschluss" im Linienelement_Spline
--
-- 29.10.2000 - 1.001 (1.001)
-- Anbindung an Schema allgemeine_Geometrieobjekte
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE Punktobjekt_Modell (
   Punktobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Punktobjekt_M__hat_Knoten (
   Punktobjekt_Modell
      INTEGER NOT NULL REFERENCES Punktobjekt_Modell,
   Knoten
      INTEGER NOT NULL REFERENCES Knoten
)

CREATE TABLE Punktobjekt_M__hat_Punkt (
   Punktobjekt_Modell
      INTEGER NOT NULL REFERENCES Punktobjekt_Modell,
   Punkt
      INTEGER NOT NULL REFERENCES Punkt
)

CREATE TABLE Linienobjekt_Modell (
   Linienobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Linienobjekt_M__hat_Kante (
   Linienobjekt_Modell
      INTEGER NOT NULL REFERENCES Linienobjekt_Modell,
   Kante
      INTEGER NOT NULL REFERENCES Kante
)

CREATE TABLE Linienobjekt_M__hat_Linie (
   Linienobjekt_Modell
      INTEGER NOT NULL REFERENCES Linienobjekt_Modell,
   Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Flaechenobjekt_Modell (
   Flaechenobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Flaechenobjekt_M__hat_Masche (
   Flaechenobjekt_Modell
      INTEGER NOT NULL REFERENCES Flaechenobjekt_Modell,
   Masche
      INTEGER NOT NULL REFERENCES Masche
)

CREATE TABLE Flaechenobjekt_M__hat_Flaeche (
   Flaechenobjekt_Modell
      INTEGER NOT NULL REFERENCES Flaechenobjekt_Modell,
   Flaeche
      INTEGER NOT NULL REFERENCES Flaeche
)

CREATE TABLE Volumenobjekt_Modell (
   Volumenobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Volumenobjekt_M__hat_Koerper (
   Volumenobjekt_Modell
      INTEGER NOT NULL REFERENCES Volumenobjekt_Modell,
   Koerper
      INTEGER NOT NULL REFERENCES Koerper
)

CREATE TABLE Volumenobjekt_M__hat_Volumen (
   Volumenobjekt_Modell
      INTEGER NOT NULL REFERENCES Volumenobjekt_Modell,
   Volumen
      INTEGER NOT NULL REFERENCES Volumen
)

CREATE TABLE Raumbezugsart (
   Raumbezugsart_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Knoten (
   Knoten_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Knoten_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Knoten__hat_Punkt (
   Knoten
      INTEGER NOT NULL REFERENCES Knoten,
   Punkt
      INTEGER NOT NULL REFERENCES Punkt
)

CREATE TABLE isolierter_Knoten (
   isolierter_Knoten_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (isolierter_Knoten_ID) REFERENCES Knoten,
   liegt_in_Masche
      INTEGER REFERENCES Masche
)

CREATE TABLE nicht_isolierter_Knoten (
   nicht_isolierter_Knoten_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (nicht_isolierter_Knoten_ID) REFERENCES Knoten
)

CREATE TABLE Kante (
   Kante_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Kante_ID) REFERENCES Raumbezugsart,
   beginnt_bei_Knoten
      INTEGER REFERENCES nicht_isolierter_Knoten,
   endet_bei_Knoten
      INTEGER REFERENCES nicht_isolierter_Knoten
)

CREATE TABLE Kante__hat_Linie (
   Kante
      INTEGER NOT NULL REFERENCES Kante,
   Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Masche (
   Masche_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Masche_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Masche__hat_Flaeche (
   Masche
      INTEGER NOT NULL REFERENCES Masche,
   Flaeche
      INTEGER NOT NULL REFERENCES Flaeche
)

CREATE TABLE Masche__hat_Kante (
   Masche
      INTEGER NOT NULL REFERENCES Masche,
   Kante
      INTEGER NOT NULL REFERENCES Kante
)

CREATE TABLE Koerper (
   Koerper_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Koerper_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Koerper__hat_Volumen (
   Koerper
      INTEGER NOT NULL REFERENCES Koerper,
   Volumen
      INTEGER NOT NULL REFERENCES Volumen
)

CREATE TABLE Koerper__hat_Masche (
   Koerper
      INTEGER NOT NULL REFERENCES Koerper,
   Masche
      INTEGER NOT NULL REFERENCES Masche
)

CREATE TABLE Punkt (
   Punkt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Punkt_ID) REFERENCES Raumbezugsart,
   Herkunft
      INTEGER REFERENCES Koordinatenherkunft,
   Genauigkeit
      REAL, -- Koordinatengenauigkeit
   hat_Lage
      INTEGER NOT NULL REFERENCES direct_positioning_schema.direct_position
)

CREATE TABLE Koordinatenherkunft (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(30) NOT NULL
)

INSERT INTO Koordinatenherkunft VALUES (1,'eigene Digitalisierung')
INSERT INTO Koordinatenherkunft VALUES (2,'Fremddigitalisierung')
INSERT INTO Koordinatenherkunft VALUES (3,'ATKIS')
INSERT INTO Koordinatenherkunft VALUES (4,'ALK')
INSERT INTO Koordinatenherkunft VALUES (5,'rtliche Aufnahme')

CREATE TABLE gerechneter_Punkt (
   gerechneter_Punkt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (gerechneter_Punkt_ID) REFERENCES Punkt
)

CREATE TABLE Linie (
   Linie_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Linie_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Linie__aus_Linienelementen (
   Linie
      INTEGER NOT NULL REFERENCES Linie,
   Linienelement_3D
      INTEGER NOT NULL REFERENCES Linienelement_3D,
   folgt_auf_Linienelement_3D
      INTEGER REFERENCES Linienelement_3D
)

CREATE TABLE Linienelement_3D (
   Linienelement_3D_ID
      INTEGER NOT NULL PRIMARY KEY,
   Unterbrechung
      INTEGER REFERENCES Logical_Types.Boolean,
   beginnt_bei_Punkt
      INTEGER NOT NULL REFERENCES Punkt,
   endet_bei_Punkt
      INTEGER NOT NULL REFERENCES Punkt,
   zu_Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Linienelement_Spline (
   Linienelement_Spline_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Linienelement_Spline_ID) REFERENCES Linienelement_3D,
   tangentialer_Anschluss
      INTEGER REFERENCES tangentialer_Anschluss,
   geschlossen
      INTEGER REFERENCES Logical_Types.Boolean,
   Kruemmung_am_Anfang
      REAL,
   Kruemmung_am_Ende
      REAL,
   Tangente_am_Anfang
      REAL, -- Winkel
   Tangente_am_Ende
      REAL -- Winkel
)

CREATE TABLE Spline__hat_Stuetzpunkte (
   Linienelement_Spline
      INTEGER NOT NULL REFERENCES Linienelement_Spline,
   Punkt
      INTEGER NOT NULL REFERENCES Punkt,
   folgt_auf_Punkt
      INTEGER REFERENCES Punkt
)

CREATE TABLE tangentialer_Anschluss (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(20) NOT NULL
)

INSERT INTO tangentialer_Anschluss VALUES (0,'am Anfang')
INSERT INTO tangentialer_Anschluss VALUES (1,'am Ende')
INSERT INTO tangentialer_Anschluss VALUES (2,'an beiden Enden')

CREATE TABLE gerades_Linienelement (
   gerades_Linienelement_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (gerades_Linienelement_ID) REFERENCES Linienelement_3D
)

CREATE TABLE Kreisbogen (
   Kreisbogen_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Kreisbogen_ID) REFERENCES Linienelement_3D,
   hat_Zwischenpunkt
      INTEGER NOT NULL REFERENCES Punkt
)

CREATE TABLE Linie_Flaechenelement (
   Linie_Flaechenelement_ID
      INTEGER NOT NULL PRIMARY KEY,
   bei_Linienfunktion
      INTEGER NOT NULL REFERENCES Linienfunktion,
   Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Linienfunktion (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(20) NOT NULL
)

INSERT INTO Linienfunktion VALUES (0,'einschlieende Linie')
INSERT INTO Linienfunktion VALUES (1,'ausschlieende Linie')

CREATE TABLE Flaeche (
   Flaeche_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Flaeche_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Flaechenelement (
   Flaechenelement_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Flaechenelement_ID) REFERENCES Flaeche,
   beschrieben_durch_Linien
      INTEGER NOT NULL REFERENCES Linie_Flaechenelement
)

CREATE TABLE komplexe_Flaeche (
   komplexe_Flaeche_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (komplexe_Flaeche_ID) REFERENCES Flaeche,
   hat_erste_Flaeche
      INTEGER NOT NULL REFERENCES Flaeche,
   hat_zweite_Flaeche
      INTEGER NOT NULL REFERENCES Flaeche
)

CREATE TABLE Volumen (
   Volumen_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Volumen_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Volumen__hat_Flaeche (
   Volumen
      INTEGER NOT NULL REFERENCES Volumen,
   Flaeche
      INTEGER NOT NULL REFERENCES Flaeche
)

CREATE TABLE BoundingBox (
   BoundingBox_ID
      INTEGER NOT NULL PRIMARY KEY,
   lu
      INTEGER NOT NULL REFERENCES direct_positioning_schema.direct_position,
   lo
      INTEGER NOT NULL REFERENCES direct_positioning_schema.direct_position,
   ru
      INTEGER NOT NULL REFERENCES direct_positioning_schema.direct_position,
   ro
      INTEGER NOT NULL REFERENCES direct_positioning_schema.direct_position
)



CREATE SCHEMA direct_positioning_schema

-- Historie:
--
-- 29.06.2004 - 1.007 (1.009)
-- Anpassung an ASB-Netzdaten, Stand September 2002
--
-- 03.09.2003 - 1.006 (1.008)
-- Przisierung des Zusammenhangs von Linien
-- Ergnzung von Flchengeometrie fr Erwerbsflche
-- und Nutzungsart_Teilflaeche
-- Anbindung des Schemas kologie
--
-- 31.05.2002 - 1.005 (1.007)
-- Erweiterung Linienelement_3D, Linienelement_Spline
-- gem Dokument N0030
--
-- 24.10.2001 - 1.004 (1.005)
-- Korrekturen in Schlsseltabellen
--
-- 12.09.2001 - 1.003 (1.004)
-- berarbeitung in Folge des nderungsantrags A0006
-- Beziehung zum Schema Unfall ergnzt
--
-- 18.12.2000 - 1.002 (1.002)
-- Korrektur: Ergnzung der Informationen "geschlossen"
-- und "tangentialer Anschluss" im Linienelement_Spline
--
-- 29.10.2000 - 1.001 (1.001)
-- Anbindung an Schema allgemeine_Geometrieobjekte
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE direct_position (
   direct_position_ID
      INTEGER NOT NULL PRIMARY KEY,
   in_pos_ref_system
      VARCHAR(30),
   Koordinate_1
      REAL NOT NULL,
   Koordinate_2
      REAL NOT NULL,
   Koordinate_3
      REAL,
   in_coordinate_system
      VARCHAR(30)
)

